Oracle Coherence for C++ API
Release 3.6.0.0
E15728-01

- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# KeyExtractor Class Reference

`#include <coherence/util/extractor/KeyExtractor.hpp>`

Inherits AbstractExtractor.

List of all members.

## Detailed Description

The KeyExtractor is a special purpose ValueExtractor implementation that serves as an indicator that a query should be run against the key objects rather than the values.

The major difference between the KeyExtractor and a standard ReflectionExtractor is that when used in various EntryFilter implementations it forces the evaluation of entry keys rather than entry values.

For example, consider a key object that consists of two properties: "FirstName" and "LastName". To retrieve all keys that have a value of the "LastName" property equal to "Smith", the following query could be used:

     ValueExtractor::View extractor = KeyExtractor::create("getLastName");
     Set::View setKeys = cache->keySet(EqualsFilter::create(extractor, "Smith"));

As of Coherence 3.5, the same effect can be achieved for subclasses of the AbstractExtractor, for example:

     ValueExtractor::View vExtractor = ReflectionExtractor::create("getLastName",
           NULL, AbstractExtractor::KEY);
     Set::View setKeys = cache->keySet(EqualsFilter::create(vExtractor, "Smith"));

Author:
  djl 2008.03.24

## Public Types
typedef spec::Handle | Handle
| KeyExtractor Handle definition.
typedef spec::View | View
| KeyExtractor View definition.
typedef spec::Holder | Holder
| KeyExtractor Holder definition.
## Public Member Functions
virtual Object::Holder | extract (Object::Holder ohTarget) const
  | Extract the value from the passed object. The returned value may be NULL. Parameters:
  | ohTarget | an Object to retrieve the value from
  Returns: the extracted value; NULL is an acceptable value Exceptions:
  | ClassCastException | if this ValueExtractor is incompatible with the passed object to extract a value from and the implementation requires the passed object to be of a certain type
  | Exception | if this ValueExtractor encounters an exception in the course of extracting the value
  | IllegalArgumentException | if this ValueExtractor cannot handle the passed object for any other reason; an implementor should include a descriptive message
virtual void | readExternal (PofReader::Handle hIn)
virtual void | writeExternal (PofWriter::Handle hOut) const
virtual bool | equals (Object::View v) const
virtual size32_t | hashCode () const
| Return a hash code value for the Object. This method is supported for the benefit of hash-based containers. The general contract of `hashCode` is: Whenever it is invoked on the same Object more than once during an execution of an application, the `hashCode` method must consistently return the same value, provided no information used in `equals` comparisons on the object is modified. This value need not remain consistent from one execution of an application to another execution of the same application. If two Objects are equal according to the `equals` method, then calling the `hashCode` method on each of the two Objects must produce the same value. It is not required that if two Objects are unequal according to the `equals` method, then calling the `hashCode` method on each of the two objects must produce distinct results. However, the programmer should be aware that producing distinct results for unequal objects may improve the performance of hash-based containers. The default implementation is identity based. Returns: a hash code value for this Object
virtual void | toStream (std::ostream &out) const
| Output a human-readable description of this Object to the given stream. coherence::lang::operator<<(std::ostream, Object::View) is defined and will call into the toStream method, to output Objects. If a managed String object is desired, the COH_TO_STRING macro can be used to build up a String from streamable contents.
     Object::View vKey   = ...
     Object::View vValue = ...
     std::cout << vKey << " = " << vValue << std::endl;

     String::Handle hs = COH_TO_STRING(vKey << " = " << vValue);
  Parameters:
  | out | the stream used to output the description
virtual ValueExtractor::View | getExtractor () const
| Obtain the underlying ValueExtractor.
## Protected Member Functions
| KeyExtractor ()
| Create and return a Handle to a new Object instance.
| KeyExtractor (ValueExtractor::View vExtractor)
| Construct a KeyExtractor based on a specified ValueExtractor.
## Protected Attributes
MemberView < ValueExtractor > | m_vExtractor
| The underlying ValueExtractor.

## Constructor & Destructor Documentation

KeyExtractor | ( | ValueExtractor::View | vExtractor | ) | `[protected]`

Construct a KeyExtractor based on a specified ValueExtractor.

Parameters:

  | vExtractor | the underlying ValueExtractor

## Member Function Documentation

virtual ValueExtractor::View getExtractor | ( |  | ) | const `[virtual]`

Obtain the underlying ValueExtractor.

Returns:
  the ValueExtractor

The documentation for this class was generated from the following file:

- coherence/util/extractor/KeyExtractor.hpp

Copyright © 2000, 2010, Oracle and/or its affiliates. All rights reserved.